Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/CommonDef.h	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/CommonDef.h	(revision 541)
@@ -58,5 +58,5 @@
 #if H_MV
 #define NV_VERSION        "0.3"                 ///< Current software version
-#define HM_VERSION        "10.1"                ///< 
+#define HM_VERSION        "11.0"                ///< 
 #else
 #define NV_VERSION        "10.1"                 ///< Current software version
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComPic.h	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComPic.h	(revision 541)
@@ -133,10 +133,8 @@
 #endif
 #endif
-
 #if H_3D_QTLPC
   Bool          getReduceBitsFlag ()             { return m_bReduceBitsQTL;     }
   Void          setReduceBitsFlag ( Bool bFlag ) { m_bReduceBitsQTL = bFlag;    }
 #endif
-
   Bool          getUsedByCurr()             { return m_bUsedByCurr; }
   Void          setUsedByCurr( Bool bUsed ) { m_bUsedByCurr = bUsed; }
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.h	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TComSlice.h	(revision 541)
@@ -977,5 +977,4 @@
   Bool        m_bUsePC;
 #endif
-
   // Parameter
   Int         m_bitDepthY;
@@ -1175,5 +1174,4 @@
   Int  getMinHorizontalCtuOffsetPlus1 ( Int i )            { return m_minHorizontalCtuOffsetPlus1 [ i ];}
 #endif
-
 #if H_3D_QTLPC
   Void setUseQTL( Bool b ) { m_bUseQTL = b;    }
@@ -1182,5 +1180,4 @@
   Bool getUsePC ()         { return m_bUsePC;  }
 #endif
-
 #if H_3D
   Void initCamParaSPS      (  UInt uiViewIndex, UInt uiCamParPrecision = 0, Bool bCamParSlice = false, Int** aaiScale = 0, Int** aaiOffset = 0 );
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TypeDef.h	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibCommon/TypeDef.h	(revision 541)
@@ -69,6 +69,4 @@
 /////////////////////////////////////////////////////////////////////////////////////////
 #if H_MV
-#define H_MV_FIX1071                      1  //< Fix on Fix1071, same as in HTM 11
-#define H_MV_FIX_VPS_POINTER              1  //< Changed m_vps in TEncCfg to pointer to avoid mismatches between layers and avoid erroneous shallow copy. 
 #define H_MV_ENC_DEC_TRAC                 1  //< CU/PU level tracking
 #endif
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 541)
@@ -745,5 +745,4 @@
     }
 #endif
-
     ////   sps_extension_vui_parameters( ) END
     READ_UVLC( uiCode, "sps_shvc_reserved_zero_idc" ); 
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 541)
@@ -823,5 +823,4 @@
 
   UInt uiSymbol;
-
 #if H_3D_QTLPC
   Bool bParseSplitFlag    = true;
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 541)
@@ -551,5 +551,4 @@
     }  
   } 
-
 #if H_3D_QTLPC
   if( depthFlag )
@@ -559,5 +558,4 @@
   }
 #endif
-
   ////   sps_extension_vui_parameters( ) END
   WRITE_UVLC( 0, "sps_shvc_reserved_zero_idc" ); 
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCfg.h	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCfg.h	(revision 541)
@@ -313,5 +313,5 @@
   Bool      m_TransquantBypassEnableFlag;                     ///< transquant_bypass_enable_flag setting in PPS.
   Bool      m_CUTransquantBypassFlagValue;                    ///< if transquant_bypass_enable_flag, the fixed value to use for the per-CU cu_transquant_bypass_flag.
-#if H_MV_FIX_VPS_POINTER
+#if H_MV
   TComVPS*  m_cVPS;                                           ///< pointer to VPS, same for all layers
 #else
@@ -401,10 +401,8 @@
   Bool      m_useDLT;
 #endif
-
 #if H_3D_QTLPC
   Bool      m_bUseQTL;
   Bool      m_bUsePC;
 #endif
-
 #endif
 public:
@@ -813,5 +811,5 @@
   Bool      getCUTransquantBypassFlagValue()          { return m_CUTransquantBypassFlagValue; }
   Void      setCUTransquantBypassFlagValue(Bool flag) { m_CUTransquantBypassFlagValue = flag; }
-#if H_MV_FIX_VPS_POINTER
+#if H_MV
   Void      setVPS           ( TComVPS *p ) { m_cVPS = p;    }
   TComVPS*  getVPS           ()             { return m_cVPS; }
@@ -952,5 +950,4 @@
   Void      setUseDLT                       ( Bool b) { m_useDLT = b;    }
 #endif
-
 #if H_3D_QTLPC
   Void      setUseQTL                       ( Bool b ) { m_bUseQTL = b;    }
@@ -959,5 +956,4 @@
   Bool      getUsePC                        ()         { return m_bUsePC;  }
 #endif
-
 #endif // H_3D
 };
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCu.cpp	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncCu.cpp	(revision 541)
@@ -400,5 +400,4 @@
   Bool bTryNx2N           = true;
 #endif
-
   // get Original YUV data from picture
   m_ppcOrigYuv[uiDepth]->copyFromPicYuv( pcPic->getPicYuvOrg(), rpcBestCU->getAddr(), rpcBestCU->getZorderIdxInCU() );
@@ -494,5 +493,4 @@
 
       rpcTempCU->initEstData( uiDepth, iQP );
-
 #if H_3D_QTLPC
       //logic for setting bTrySplit using the partition information that is stored of the texture colocated CU
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 541)
@@ -730,5 +730,4 @@
 {
   PartSize eSize         = pcCU->getPartitionSize( uiAbsPartIdx );
-
 #if H_3D_QTLPC
   TComSPS *sps           = pcCU->getPic()->getSlice(0)->getSPS();
@@ -751,5 +750,4 @@
   }
 #endif
-
   if ( pcCU->isIntra( uiAbsPartIdx ) )
   {
@@ -1011,5 +1009,4 @@
   
   assert( uiCtx < 3 );
-
 #if H_3D_QTLPC
   Bool bCodeSplitFlag    = true;
@@ -1036,5 +1033,4 @@
   }
 #endif
-
   m_pcBinIf->encodeBin( uiCurrSplitFlag, m_cCUSplitFlagSCModel.get( 0, 0, uiCtx ) );
 #if !H_MV_ENC_DEC_TRAC
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 541)
@@ -1617,5 +1617,4 @@
     rpcPic->setReduceBitsFlag(true);
 #endif
-
     TComDataCU*& pcCU = rpcPic->getCU( uiCUAddr );    
     if ( pcSlice->getSPS()->getUseSAO() && (pcSlice->getSaoEnabledFlag()||pcSlice->getSaoEnabledFlagChroma()) )
Index: /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.cpp	(revision 540)
+++ /branches/HTM-DEV-0.3-dev2/source/Lib/TLibEncoder/TEncTop.cpp	(revision 541)
@@ -290,5 +290,5 @@
   
   /* set the VPS profile information */
-#if H_MV_FIX_VPS_POINTER
+#if H_MV
   // This seems to be incorrect, but irrelevant for the MV-HEVC
   *(m_cVPS->getPTL()) = *m_cSPS.getPTL();
@@ -668,9 +668,5 @@
 {
 #if H_MV
-#if H_MV_FIX_VPS_POINTER
   if( getVPS()->getNumDirectRefLayers( getLayerIdInVps() ) > 0 )
-#else
-  if( m_cVPS.getNumDirectRefLayers( getLayerIdInVps() ) > 0 )
-#endif
   {
     m_cPPS.setListsModificationPresentFlag( true );